﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;

namespace Custom_DataReader_Streaming
{
    public class CustomObjectDataReader : IDataReader
    {
        private List<CustomObject> _objectList = null;
        private int _currentIndex = -1;
        public CustomObjectDataReader(List<CustomObject> o)
        {
            _objectList = o;
        }


        public int FieldCount
        {
            get { return 2; } // There are two fields in the TestClass class
        }

        public bool Read()
        {
            if ((_currentIndex + 1) < _objectList.Count)
            {
                _currentIndex++;
                return true;
            }
            else
            {
                return false;
            }
        }

        public string GetName(int i)
        {
            switch (i)
            {
                case 0:
                    return "UniqueId";
                case 1:
                    return "RandomNumber";
                default:
                    return string.Empty;
            }
        }

        public int GetOrdinal(string name)
        {
            switch (name)
            {
                case "UniqueId":
                    return 0;
                case "RandomNumber":
                    return 1;
                default:
                    return -1;
            }
        }

        public object GetValue(int i)
        {
            switch (i)
            {
                case 0:
                    return _objectList[i].UniqueId;
                case 1:
                    return _objectList[i].RandomNumber;
                default:
                    return null;
            }
        }






        public void Close()
        {
            throw new NotImplementedException();
        }
        public int Depth
        {
            get { throw new NotImplementedException(); }
        }
        public DataTable GetSchemaTable()
        {
            throw new NotImplementedException();
        }
        public bool IsClosed
        {
            get { throw new NotImplementedException(); }
        }
        public bool NextResult()
        {
            throw new NotImplementedException();
        }
        public int RecordsAffected
        {
            get { throw new NotImplementedException(); }
        }
        public void Dispose()
        {
            throw new NotImplementedException();
        }
        public bool GetBoolean(int i)
        {
            throw new NotImplementedException();
        }
        public byte GetByte(int i)
        {
            throw new NotImplementedException();
        }
        public long GetBytes(int i, long fieldOffset, byte[] buffer, int bufferoffset, int length)
        {
            throw new NotImplementedException();
        }
        public char GetChar(int i)
        {
            throw new NotImplementedException();
        }
        public long GetChars(int i, long fieldoffset, char[] buffer, int bufferoffset, int length)
        {
            throw new NotImplementedException();
        }
        public IDataReader GetData(int i)
        {
            throw new NotImplementedException();
        }
        public string GetDataTypeName(int i)
        {
            throw new NotImplementedException();
        }
        public DateTime GetDateTime(int i)
        {
            throw new NotImplementedException();
        }
        public decimal GetDecimal(int i)
        {
            throw new NotImplementedException();
        }
        public double GetDouble(int i)
        {
            throw new NotImplementedException();
        }
        public Type GetFieldType(int i)
        {
            throw new NotImplementedException();
        }
        public float GetFloat(int i)
        {
            throw new NotImplementedException();
        }
        public Guid GetGuid(int i)
        {
            throw new NotImplementedException();
        }
        public short GetInt16(int i)
        {
            throw new NotImplementedException();
        }
        public int GetInt32(int i)
        {
            throw new NotImplementedException();
        }
        public long GetInt64(int i)
        {
            throw new NotImplementedException();
        }
        public string GetString(int i)
        {
            throw new NotImplementedException();
        }
        public int GetValues(object[] values)
        {
            throw new NotImplementedException();
        }
        public bool IsDBNull(int i)
        {
            throw new NotImplementedException();
        }
        public object this[string name]
        {
            get { throw new NotImplementedException(); }
        }
        public object this[int i]
        {
            get { throw new NotImplementedException(); }
        }
    }
}
